/*
 * Presenter Club - Make Great Presentations, Faster
 * Copyright (C) 2016 Sam Parkinson <sam@sam.today>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

$modal-z: 10000;
.Modal__background {
    position: fixed; 
    top: 0; left: 0; bottom: 0; right: 0;
    z-index: $modal-z - 1;

    display: flex;
    justify-content: center;
    align-items: center;

    transition: background _duration(transition) ease-in-out;
    background: opacify(_palette(border-bg), 0.25);
}
.OnboardingTransition-leave-active.Modal__background {
    background: transparent;
}


.Modal {
    background: white;
    border-radius: _size(border-radius);
    box-shadow: 0 0 10px _palette(border2);

    max-width: 25em;
    display: flex;
    flex-direction: column;

    p {
        padding: 0.5em;
        margin-bottom: 0;
    }

    transition: transform _duration(transition) ease-in-out;
}
.OnboardingTransition-leave-active .Modal {
    transform: translateY(100vh);
}
.Modal__header {
    display: flex;
    justify-content: center;
    padding: 1em;

    height: 3em;

    background: _palette(header-bg);
    color: _palette(header-fg);
}
.Modal__title {
    margin-top: 0.75em;
}
.Modal__actions {
    display: flex;
    padding: 0.5em;
    justify-content: center;
    background: _palette(border-bg);
}

.OnboardingTip {
    position: fixed;
    bottom: 0; left: 2em; right: 12em;
    z-index: $modal-z - 2;

    background: white;
    border: _size(border-radius) solid _palette(accent);
    border-bottom: 0;
    border-top-left-radius:  _size(border-radius);
    border-top-right-radius: _size(border-radius);
    box-shadow: 0 0 10px _palette(border2);

    display: flex;
    justify-content: space-between;
    padding: 0.5em;

    transform-origin: bottom center;
    transition: all _duration(transition) ease-in-out;
}
.OnboardingTip--success {
    background: _palette(colors, green);
}
.OnboardingTransition-enter.OnboardingTip {
    transform: rotateX(90deg);
}
.OnboardingTransition-enter.OnboardingTransition-enter-active.OnboardingTip,
.OnboardingTransition-leave.OnboardingTip {
    transform: rotateX(0);
}
.OnboardingTransition-leave.OnboardingTransition-leave-active.OnboardingTip {
    box-shadow: 5px 5px 20px _palette(border2);
    transform: translateX(-120%);
    background: lighten(#ace0a6, 0.5);
}

.OnboardingTip__skip {
    color: _palette(fg-light);
    font-size: 0.5em;
    align-self: center;
}

.OnboardingTip__button {
    font-size: 0.4em;
    align-self: center;
}

@keyframes OnboardingHighlight--appear {
    0% { filter: 0; box-shadow: 0; }
    100% {
        filter: sepia(50%);
        box-shadow: 0 0 20px _palette(colors, orange);
    }
}
@keyframes OnboardingHighlight--pulse {
    0%, 100% {
        filter: sepia(50%);
        box-shadow: 0 0 20px _palette(colors, orange);
    }
    50% {
        filter: sepia(75%);
        box-shadow: 0 0 40px _palette(colors, orange);
    }
}
.OnboardingHighlight {
    animation: OnboardingHighlight--appear
                    _duration(transition)
                    ease-in-out,
               OnboardingHighlight--pulse
                    (_duration(transition) * 6)
                    _duration(transition)
                    linear
                    infinite;
}
